# Contributing

When contributing to this repository, please first discuss the change you wish to make via issue,
[email](mailto:vib.singlecell.nf@gmail.com), or any other method (i.e. [Gitter](https://gitter.im/vib-singlecell-nf/community)) with the owners of this repository before making a change. 

Please note we have a code of conduct, please follow it in all your interactions with the project.

## Pull Request Process

All in-development pull requests must be submitted to the `develop` branch. Only the `develop`
branch can be merged into the `master` branch, this will be done when sufficient changes are in
place to increase the version of the pipeline and will be performed at the discetion of the lead
developers.

1. Ensure any install or build dependencies are removed before the end of the layer when doing a 
build.
2. Update the README.md with details of changes to the interface, this includes new environment
variables, exposed ports, useful file locations and container parameters.
3. Increase the version numbers in any examples files and the README.md to the new version that 
this Pull Request would represent. The versioning scheme we use is [SemVer](http://semver.org/).
4. Ensure that all current and new tests pass successfully.
5. The Pull Request can be merged once you have the sign-off of two other developers, and must 
be merged by one of the lead developers.
